
'External Add
Public Function Add(ByVal Name As String, Optional ByVal Template As String, Optional ByVal Path As String, Optional ServerEncoding As String, Optional ByVal Comment As String) As pgDatabase
Attribute Add.VB_Description = "Add a new database object."
On Error GoTo Err_Handler
objServer.iLogEvent "Entering " & App.Title & ":Databases.Add(" & QUOTE & Name & QUOTE & ", " & QUOTE & Template & QUOTE & ", " & QUOTE & Path & QUOTE & ", " & QUOTE & Comment & QUOTE & ")", etFullDebug

Dim rs As New Recordset
Dim rsComment As New Recordset
Dim rsUser As New Recordset
Dim objNewMember As pgDatabase
Dim szSQL As String
  
  'Create a new object
  Set objNewMember = New pgDatabase

  'Generate the SQL query to create the new object and execute
  szSQL = "CREATE DATABASE " & fmtID(Name) & " WITH"
  If Path <> "" Then szSQL = szSQL & " LOCATION = '" & dbSZ(Path) & "'"
  If Template <> "" Then
    szSQL = szSQL & " TEMPLATE = " & Template
  Else
    szSQL = szSQL & " TEMPLATE = template0"
  End If
  If ServerEncoding <> "" Then szSQL = szSQL & " ENCODING = '" & dbSZ(ServerEncoding) & "'"
  objServer.ExecSQL szSQL, objServer.Connection
  
  'Generate and execute the SQL to retrieve *all* properties of the new object
  If objVersion.VersionNum >= 7.3 Then
    szSQL = SQL_GET_DATABASES7_3 & " WHERE datname = '" & dbSZ(Name) & "'"
  Else
    szSQL = SQL_GET_DATABASES7_1 & " WHERE datname = '" & dbSZ(Name) & "'"
  End If
  Set rs = objServer.ExecSQL(szSQL, objServer.Connection)
  
  'Create a new member of the collection
  If Not rs.EOF Then
    If objVersion.VersionNum >= 7.3 Then
      iAdd rs.Fields("oid"), rs!datname & "", rs!datpath & "", rs!datowner & "", rs!ServerEncoding & "", ToBool(rs!datallowconn), rs!datconfig & "", rs!datacl & ""
    Else
      iAdd rs.Fields("oid"), rs!datname & "", rs!datpath & "", rs!datowner & "", rs!ServerEncoding & "", ToBool(rs!datallowconn)
    End If
    If Comment <> "" Then objNewMember.Comment = Comment
  End If
  
  'Return the object created
  Set Add = objNewMember
  
  'Cleanup
  Set objNewMember = Nothing
  If rs.State <> adStateClosed Then rs.Close
  Set rs = Nothing
  
  Exit Function
Err_Handler:
  If rs.State <> adStateClosed Then rs.Close
  Set rs = Nothing
  If rsComment.State <> adStateClosed Then rsComment.Close
  Set rsComment = Nothing
  objServer.iLogError Err.Number, Err.Description
  
End Function

